Loading...
Searching...
No Matches
pcl::SHOTLocalReferenceFrameEstimationOMP< PointInT, PointOutT > Class Template Reference
Module features

SHOTLocalReferenceFrameEstimation estimates the Local Reference Frame used in the calculation of the (SHOT) descriptor. More...

`#include <pcl/features/shot_lrf_omp.h>`

Inheritance diagram for pcl::SHOTLocalReferenceFrameEstimationOMP< PointInT, PointOutT >:

## Public Types

using | Ptr = shared_ptr<SHOTLocalReferenceFrameEstimationOMP<PointInT, PointOutT> >
using | ConstPtr = shared_ptr<const SHOTLocalReferenceFrameEstimationOMP<PointInT, PointOutT> >
Public Types inherited from pcl::SHOTLocalReferenceFrameEstimation< PointInT, ReferenceFrame >
using | Ptr
using | ConstPtr
Public Types inherited from pcl::Feature< PointInT, ReferenceFrame >
using | BaseClass
using | Ptr
using | ConstPtr
using | KdTree
using | KdTreePtr
using | PointCloudIn
using | PointCloudInPtr
using | PointCloudInConstPtr
using | PointCloudOut
using | SearchMethod
using | SearchMethodSurface
Public Types inherited from pcl::PCLBase< PointInT >
using | PointCloud
using | PointCloudPtr
using | PointCloudConstPtr
using | PointIndicesPtr
using | PointIndicesConstPtr

## Public Member Functions

| SHOTLocalReferenceFrameEstimationOMP ()
| Constructor.
| ~SHOTLocalReferenceFrameEstimationOMP () override=default
| Empty destructor.
void | setNumberOfThreads (unsigned int nr_threads=0)
| Initialize the scheduler and set the number of threads to use.
Public Member Functions inherited from pcl::SHOTLocalReferenceFrameEstimation< PointInT, ReferenceFrame >
| SHOTLocalReferenceFrameEstimation ()
| Constructor.
| ~SHOTLocalReferenceFrameEstimation () override=default
| Empty destructor.
Public Member Functions inherited from pcl::Feature< PointInT, ReferenceFrame >
| Feature ()
| Empty constructor.
void | setSearchSurface (const PointCloudInConstPtr &cloud)
| Provide a pointer to a dataset to add additional information to estimate the features for every point in the input dataset.
PointCloudInConstPtr | getSearchSurface () const
| Get a pointer to the surface point cloud dataset.
void | setSearchMethod (const KdTreePtr &tree)
| Provide a pointer to the search object.
KdTreePtr | getSearchMethod () const
| Get a pointer to the search method used.
double | getSearchParameter () const
| Get the internal search parameter.
void | setKSearch (int k)
| Set the number of k nearest neighbors to use for the feature estimation.
int | getKSearch () const
| get the number of k nearest neighbors used for the feature estimation.
void | setRadiusSearch (double radius)
| Set the sphere radius that is to be used for determining the nearest neighbors used for the feature estimation.
double | getRadiusSearch () const
| Get the sphere radius used for determining the neighbors.
void | compute (PointCloudOut &output)
| Base method for feature estimation for all points given in <setInputCloud (), setIndices ()> using the surface in setSearchSurface () and the spatial locator in setSearchMethod ().
Public Member Functions inherited from pcl::PCLBase< PointInT >
| PCLBase ()
| Empty constructor.
| PCLBase (const PCLBase &base)
| Copy constructor.
virtual | ~PCLBase ()=default
| Destructor.
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset.
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset.
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (std::size_t row_start, std::size_t col_start, std::size_t nb_rows, std::size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud.
IndicesPtr | getIndices ()
| Get a pointer to the vector of indices used.
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used.
const PointInT & | operator[] (std::size_t pos) const
| Override PointCloud operator[] to shorten code.

## Protected Types

using | PointCloudIn = typename Feature<PointInT, PointOutT>::PointCloudIn
using | PointCloudOut = typename Feature<PointInT, PointOutT>::PointCloudOut
Protected Types inherited from pcl::SHOTLocalReferenceFrameEstimation< PointInT, ReferenceFrame >
using | PointCloudIn
using | PointCloudOut

## Protected Member Functions

void | computeFeature (PointCloudOut &output) override
| Feature estimation method.
Protected Member Functions inherited from pcl::SHOTLocalReferenceFrameEstimation< PointInT, ReferenceFrame >
float | getLocalRF (const int &index, Eigen::Matrix3f &rf)
| Computes disambiguated local RF for a point index.
void | computeFeature (PointCloudOut &output) override
| Feature estimation method.
Protected Member Functions inherited from pcl::Feature< PointInT, ReferenceFrame >
const std::string & | getClassName () const
| Get a string representation of the name of this class.
virtual bool | initCompute ()
| This method should get called before starting the actual computation.
virtual bool | deinitCompute ()
| This method should get called after ending the actual computation.
int | searchForNeighbors (std::size_t index, double parameter, pcl::Indices &indices, std::vector< float > &distances) const
| Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface.
Protected Member Functions inherited from pcl::PCLBase< PointInT >
bool | initCompute ()
| This method should get called before starting the actual computation.
bool | deinitCompute ()
| This method should get called after finishing the actual computation.

## Protected Attributes

unsigned int | threads_
| The number of threads the scheduler should use.
Protected Attributes inherited from pcl::Feature< PointInT, ReferenceFrame >
std::string | feature_name_
| The feature name.
SearchMethodSurface | search_method_surface_
| The search method template for points.
PointCloudInConstPtr | surface_
| An input point cloud describing the surface that is to be used for nearest neighbors estimation.
KdTreePtr | tree_
| A pointer to the spatial search object.
double | search_parameter_
| The actual search parameter (from either search_radius_ or k_).
double | search_radius_
| The nearest neighbors search radius for each point.
int | k_
| The number of K nearest neighbors to use for each point.
bool | fake_surface_
| If no surface is given, we use the input PointCloud as the surface.
Protected Attributes inherited from pcl::PCLBase< PointInT >
PointCloudConstPtr | input_
| The input point cloud dataset.
IndicesPtr | indices_
| A pointer to the vector of point indices to use.
bool | use_indices_
| Set to true if point indices are used.
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud.

## Detailed Description

template<typename PointInT, typename PointOutT = ReferenceFrame>
class pcl::SHOTLocalReferenceFrameEstimationOMP< PointInT, PointOutT >

SHOTLocalReferenceFrameEstimation estimates the Local Reference Frame used in the calculation of the (SHOT) descriptor.

Note
  If you use this code in any academic work, please cite:

- F. Tombari, S. Salti, L. Di Stefano Unique Signatures of Histograms for Local Surface Description. In Proceedings of the 11th European Conference on Computer Vision (ECCV), Heraklion, Greece, September 5-11 2010.
- F. Tombari, S. Salti, L. Di Stefano A Combined Texture-Shape Descriptor For Enhanced 3D Feature Matching. In Proceedings of the 18th International Conference on Image Processing (ICIP), Brussels, Belgium, September 11-14 2011.

Author
  Samuele Salti, Federico Tombari

Definition at line 66 of file shot_lrf_omp.h.

## Member Typedef Documentation

## ConstPtr

template<typename PointInT, typename PointOutT = ReferenceFrame>

using pcl::SHOTLocalReferenceFrameEstimationOMP< PointInT, PointOutT >::ConstPtr = shared_ptr<const SHOTLocalReferenceFrameEstimationOMP<PointInT, PointOutT> >

Definition at line 70 of file shot_lrf_omp.h.

## PointCloudIn

template<typename PointInT, typename PointOutT = ReferenceFrame>

using pcl::SHOTLocalReferenceFrameEstimationOMP< PointInT, PointOutT >::PointCloudIn = typename Feature<PointInT, PointOutT>::PointCloudIn

protected

Definition at line 98 of file shot_lrf_omp.h.

## PointCloudOut

template<typename PointInT, typename PointOutT = ReferenceFrame>

using pcl::SHOTLocalReferenceFrameEstimationOMP< PointInT, PointOutT >::PointCloudOut = typename Feature<PointInT, PointOutT>::PointCloudOut

protected

Definition at line 99 of file shot_lrf_omp.h.

## Ptr

template<typename PointInT, typename PointOutT = ReferenceFrame>

using pcl::SHOTLocalReferenceFrameEstimationOMP< PointInT, PointOutT >::Ptr = shared_ptr<SHOTLocalReferenceFrameEstimationOMP<PointInT, PointOutT> >

Definition at line 69 of file shot_lrf_omp.h.

## Constructor & Destructor Documentation

## SHOTLocalReferenceFrameEstimationOMP()

template<typename PointInT, typename PointOutT = ReferenceFrame>

pcl::SHOTLocalReferenceFrameEstimationOMP< PointInT, PointOutT >::SHOTLocalReferenceFrameEstimationOMP | ( |  | ) |

inline

Constructor.

Definition at line 72 of file shot_lrf_omp.h.

References pcl::Feature< PointInT, ReferenceFrame >::feature_name_, and setNumberOfThreads().

## ~SHOTLocalReferenceFrameEstimationOMP()

template<typename PointInT, typename PointOutT = ReferenceFrame>

pcl::SHOTLocalReferenceFrameEstimationOMP< PointInT, PointOutT >::~SHOTLocalReferenceFrameEstimationOMP | ( |  | ) |

override default

Empty destructor.

References pcl::Feature< PointInT, ReferenceFrame >::feature_name_, pcl::Feature< PointInT, ReferenceFrame >::getClassName(), pcl::SHOTLocalReferenceFrameEstimation< PointInT, ReferenceFrame >::getLocalRF(), pcl::PCLBase< PointInT >::indices_, pcl::PCLBase< PointInT >::input_, pcl::Feature< PointInT, ReferenceFrame >::search_parameter_, pcl::SHOTLocalReferenceFrameEstimation< PointInT, ReferenceFrame >::SHOTLocalReferenceFrameEstimation(), pcl::Feature< PointInT, ReferenceFrame >::surface_, and pcl::Feature< PointInT, ReferenceFrame >::tree_.

## Member Function Documentation

## computeFeature()

template<typename PointInT, typename PointOutT>

void pcl::SHOTLocalReferenceFrameEstimationOMP< PointInT, PointOutT >::computeFeature | ( | PointCloudOut & | output | ) |

override protected

Feature estimation method.

Parameters

  [out] | output | the resultant features

Definition at line 62 of file shot_lrf_omp.hpp.

References pcl::Feature< PointInT, ReferenceFrame >::getClassName(), pcl::Feature< PointInT, ReferenceFrame >::getKSearch(), pcl::SHOTLocalReferenceFrameEstimation< PointInT, ReferenceFrame >::getLocalRF(), pcl::PCLBase< PointInT >::indices_, and pcl::Feature< PointInT, ReferenceFrame >::tree_.

## setNumberOfThreads()

template<typename PointInT, typename PointOutT>

void pcl::SHOTLocalReferenceFrameEstimationOMP< PointInT, PointOutT >::setNumberOfThreads | ( | unsigned int | nr_threads = 0 | ) |

Initialize the scheduler and set the number of threads to use.

Parameters

  nr_threads | the number of hardware threads to use (0 sets the value back to automatic)

Definition at line 48 of file shot_lrf_omp.hpp.

References threads_.

Referenced by pcl::SHOTColorEstimationOMP< PointInT, PointNT, PointOutT, PointRFT >::initCompute(), pcl::SHOTEstimationOMP< PointInT, PointNT, PointOutT, PointRFT >::initCompute(), and SHOTLocalReferenceFrameEstimationOMP().

## Member Data Documentation

## threads_

template<typename PointInT, typename PointOutT = ReferenceFrame>

unsigned int pcl::SHOTLocalReferenceFrameEstimationOMP< PointInT, PointOutT >::threads_

protected

The number of threads the scheduler should use.

Definition at line 108 of file shot_lrf_omp.h.

Referenced by setNumberOfThreads().

The documentation for this class was generated from the following files:

- pcl/features/shot_lrf_omp.h
- pcl/features/impl/shot_lrf_omp.hpp